/**
 * 
 */
package corp.wattson.plinstool.core;

import java.util.ArrayList;
import java.util.List;

/**
 * @author wattazoum
 * 
 */
public abstract class AbstractItem implements Describable, Processable {
  
  protected String description;
  protected List<Option> optionList = new ArrayList<Option>();

  public void setDescription(String description) {
    this.description = description;
  }

  public void setName(String name) {
    this.name = name;
  }

  public void setOptionList(List<Option> optionList) {
    this.optionList = optionList;
  }
  protected String name;
  protected String type;

  /**
   * Get the 'description' element value.
   * 
   * @return value
   */
  public String describe() {
    return description;
  }

  /**
   * Get the list of 'option' element items.
   * 
   * @return list
   */
  public List<Option> getOptions() {
    return optionList;
  }

  /**
   * Get the 'name' attribute value.
   * 
   * @return value
   */
  public String getName() {
    return name;
  }

  /**
   * Get the 'type' attribute value.
   * 
   * @return value
   */
  public String getType() {
    return type;
  }

  /**
   * 
   */
  public void setType(String type) {
    this.type = type;
  }

  /**
   * This returns always an empty List. Implementations can override it if needed.
   */
  @Override
  public List<Describable> getIncludedDescribable() {
    return new ArrayList<Describable>();
  }
  
}
