package corp.wattson.plinstool.core;

/**
 * This class handles a primary configuration of the system.
 * 
 * @author wattazoum
 * 
 */
public class BootStrap {

  /**
   * System properties used to set a custom items package.
   */
  public static final String CUSTOM_ITEMS_PKG_SYS_PROP = "plinstool.custom.items.pkg";
  
  /**
   * Sets some system parameters in place.
   */
  public static void bootStrap() {
    String customPackage = System.getProperty(CUSTOM_ITEMS_PKG_SYS_PROP);
    if (customPackage != null) {
      ItemFactory.setCustomPackage(customPackage);
    }
  }

}
