package corp.wattson.plinstool.core;

/**
 * 
 * @author wattazoum
 *
 */
public interface Processable {

  /**
   * 
   * @author wattazoum
   *
   */
  public static class ProcessFailedException extends Exception {

    private static final long serialVersionUID = -2068392458396487862L;

    public ProcessFailedException(String message) {
      super(message);
    }

    public ProcessFailedException(String message, Throwable t) {
      super(message, t);
    }
  }

  /**
   * Exception thrown when a check for un install fails. The exception contains a message with the reason.
   * 
   * @author wattazoum
   * 
   */
  public static class NotCompliantInstallException extends Exception {

    private static final long serialVersionUID = -7483340394214606759L;

    /**
     * Constructor with a message.
     * 
     * @param message
     *          The message describing the failure.
     */
    public NotCompliantInstallException(String message) {
      super(message);
    }

    /**
     * Constructor with a message and a cause.
     * 
     * @param message
     *          The message describing the failure.
     * @param t
     *          The original cause of the failure.
     */
    public NotCompliantInstallException(String message, Throwable t) {
      super(message, t);
    }
  }

  /**
   * 
   * @throws NotCompliantInstallException
   */
  void check() throws NotCompliantInstallException;

  /**
   * 
   * @throws ProcessFailedException
   */
  void process() throws ProcessFailedException;

}
