package corp.wattson.plinstool.core;

public class MockItems {

  public static class CustomizableItem extends AbstractItem {

    Describable.ProcessableState state = Describable.ProcessableState.NOT_CHECKED;

    public CustomizableItem(Describable.ProcessableState state) {
      this.state = state;
    }
    
    @Override
    public void check() throws NotCompliantInstallException {
    }

    @Override
    public Describable.ProcessableState getState() {
      return state;
    }

    @Override
    public void process() throws ProcessFailedException {
    }

  }

  public static class FailsOnCheck extends AbstractItem {

    @Override
    public void check() throws NotCompliantInstallException {
      throw new NotCompliantInstallException("platform is not compliant");
    }

    @Override
    public Describable.ProcessableState getState() {
      return Describable.ProcessableState.NOT_CHECKED;
    }

    @Override
    public void process() throws ProcessFailedException {
    }
    
  }

  public static class FailsOnProcess extends AbstractItem {

    Describable.ProcessableState state = Describable.ProcessableState.NOT_CHECKED;
    
    @Override
    public void check() throws NotCompliantInstallException {
      state = Describable.ProcessableState.BROKEN;
      throw new NotCompliantInstallException("platform is not compliant");
    }

    @Override
    public Describable.ProcessableState getState() {
      return state;
    }

    @Override
    public void process() throws ProcessFailedException {
      state = Describable.ProcessableState.BROKEN;
      throw new ProcessFailedException("Process failed");
    }
    
  }
  
}
